SystemOrganization addCategory: #'ECompletion-Morph'!

!Debugger methodsFor: '*ecompletion' stamp: 'bar 10/18/2004 10:51'!
getClassForName: aString
	| index object |
	index := tempNames 
		indexOf: aString
		ifAbsent:[nil].
	object := index 
		ifNotNil:[self selectedContext tempAt: index]
		ifNil:
			[index := self receiver class allInstVarNames 
				indexOf: aString
				ifAbsent:[^super getClassForName: aString ].
			self receiver instVarAt: index ].
	^object 
		ifNotNil:[Transcript show: object class; cr. object class]
		ifNil:[nil]

! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 10/28/2004 08:48'!
completeFirst

	self isCompletionMorphOpen ifFalse:[^self].
	completionMorph completeFirst.! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 10/28/2004 08:49'!
currentCompiledMethod
	^nil! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 11/18/2004 10:45'!
getClassForName: aString
	| global |
	aString isEmpty ifTrue:[^nil].
	(aString = 'false' or:[aString = 'true'])
		ifTrue:[^Boolean].
	global := Smalltalk 
		at: aString asSymbol
		ifAbsent:[nil].
	global ifNotNil:[^global class].
	^self getClassFromTypeSuggestingName: aString.

! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 10/28/2004 08:49'!
completionSelectionDown

	self isCompletionMorphOpen ifFalse:[^self].
	completionMorph moveDown! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 10/28/2004 08:51'!
deleteCompletionMorph
	completionMorph notNil ifTrue:[completionMorph delete]
! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 10/28/2004 08:49'!
completionSelectionUp

	self isCompletionMorphOpen ifFalse:[^self].
	completionMorph moveUp! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 10/28/2004 08:51'!
isCompletionMorphOpen
	^completionMorph ~= nil! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 10/28/2004 10:03'!
addSymbols: aCollection
	"Add symbols to a appear in the CompletionMorph"! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 11/18/2004 16:09'!
getClassFromTypeSuggestingName: aString 
	| firstUppercaseLetter className aStream aClass |
	
	aStream := WriteStream on: String new.
	aStream nextPut: aString first asUppercase.
	aStream nextPutAll: 
		(aString 
			copyFrom: 2 to: 
			aString size).
	className := aStream contents.
	aClass := Smalltalk 
		at: className asSymbol
		ifAbsent:[nil].
	( aClass isKindOf: Class )
		ifTrue:[ ^aClass ].
	firstUppercaseLetter := aString indexOfFirstUppercaseCharacter.
	className := firstUppercaseLetter > 1 
		ifTrue:[aString copyFrom: firstUppercaseLetter to: aString size]
		ifFalse:[^nil].
	aClass := Smalltalk 
		at: className asSymbol
		ifAbsent:[nil].
	( aClass isKindOf: Class )
		ifTrue:[ ^aClass ].
	^nil
! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 10/28/2004 08:51'!
narrowCompletion
	self isCompletionMorphOpen ifFalse:[^self].
	completionMorph narrowCompletion! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 11/18/2004 22:17'!
completionSwitchToUndefined

	self isCompletionMorphOpen ifFalse:[^self].
	completionMorph switchToUndefined! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 10/28/2004 08:49'!
completionMorphDeleted
	completionMorph := nil! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 10/28/2004 08:49'!
completionInsertSelected

	completionMorph ifNil: [^false].
	^completionMorph insertSelected! !

!StringHolder methodsFor: '*ecompletion' stamp: 'bar 11/25/2004 15:05'!
completeParagraph: aParagraph editor: aParagraphEditor 
	self isCompletionMorphOpen ifTrue: [self deleteCompletionMorph].
	aParagraphEditor getCompletionSymbol isEmpty ifTrue:[^self].
	completionMorph := ECompletionMorph completeParagraph: aParagraph editor: aParagraphEditor. ! !

Morph subclass: #ECompletionMorph
	instanceVariableNames: 'paragraph allSymbols selected editor firstVisible selectedSymbols receiverClass titleStringMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ECompletion-Morph'!

ECompletionMorph class
	instanceVariableNames: 'instanceVariablesFont localVariablesFont titleFont'!

!ECompletionMorph commentStamp: 'bar 11/25/2004 10:00' prior: 0!
I show the possible completions in a menu like appearance. The user may choose an entry from my list and complete the word he was typing in the editor. I'm showed with the Tab key and will be deleted when with ESC key or when a successful completion occurs. The following keystrokes are supported:

Tab: Show this morph. When already open complete with the topmost entry
Esc: Close this morph
Ctrl+u: Change to undefined mode, that means do not narrow the selector names to the computed class
Arrow Up: Scroll up
Arrow Down: Scroll down
Enter: Complete with the selected item and close the morph
any letter or digit: Narrow the completion further

!

!ECompletionMorph methodsFor: 'private' stamp: 'pk 6/3/2004 16:31'!
visibleItemsCount.

	^ self lastVisible - self firstVisible + 1! !

!ECompletionMorph methodsFor: 'title' stamp: 'bar 11/25/2004 09:48'!
createTitle
	| transformationMorph titleString |
	receiverClass ifNil: [^self].
	transformationMorph := TransformationMorph new.
	self addMorph: transformationMorph.
	titleStringMorph := StringMorph new.
	titleStringMorph font: self class titleFont.
	transformationMorph addMorph: titleStringMorph.
	transformationMorph rotationDegrees: -90.0.
	titleString := receiverClass printString.
	titleStringMorph contents: titleString.
	transformationMorph x: 0 y: 10! !

!ECompletionMorph methodsFor: 'accessing' stamp: 'pk 5/31/2004 11:25'!
selected
	"Answer the value of selected"

	^ selected! !

!ECompletionMorph methodsFor: 'private' stamp: 'bar 10/16/2004 17:06'!
firstVisible
	^firstVisible min: selectedSymbols size! !

!ECompletionMorph methodsFor: 'accessing' stamp: 'bar 11/25/2004 09:54'!
height
	self visible 
		ifFalse: [^ECompletionMorph maxLength]
		ifTrue: 
			[^(Display height - self bounds topLeft y) / ECompletionMorph itemHeight 
				- 1 min: ECompletionMorph maxLength]! !

!ECompletionMorph class methodsFor: 'preferences' stamp: 'bar 11/18/2004 15:49'!
titleFont
	titleFont _ nil.
	titleFont ifNil:[titleFont := StrikeFont familyName: 'Accuny' size: 20 emphasized: 1 ].
	^titleFont
	! !

!ECompletionMorph class methodsFor: 'preferences' stamp: 'bar 10/17/2004 15:16'!
itemWidth

	^ 200.! !

!ECompletionMorph methodsFor: 'private' stamp: 'bar 10/18/2004 07:26'!
newSortedSelectorCollection
	^SortedCollection sortBlock: [:a :b | a value <= b value]! !

!ECompletionMorph class methodsFor: 'preferences' stamp: 'bar 10/17/2004 12:09'!
instanceVariablesFont
	instanceVariablesFont ifNil:[instanceVariablesFont := StrikeFont familyName: 'Accuny' size: 12 emphasized: 1 ].
	^instanceVariablesFont
	! !

!ECompletionMorph methodsFor: 'accessing' stamp: 'pk 5/31/2004 18:09'!
editor	
	^editor.! !

!ECompletionMorph class methodsFor: 'preferences' stamp: 'bar 10/16/2004 15:12'!
itemHeight

	"CompletionMorph itemHeight "
	
	^ 14.! !

!ECompletionMorph methodsFor: 'actions' stamp: 'bar 10/16/2004 15:17'!
insertCompletion: aString

	| caret old |
	caret := editor startIndex.
	editor selectPrecedingIdentifier.
	old := editor selection.
	editor zapSelectionWith: aString.
	editor selectAt: caret + (aString size - old size).
	editor morph invalidRect: editor morph bounds. 
! !

!ECompletionMorph methodsFor: 'actions' stamp: 'bar 11/18/2004 22:55'!
switchToUndefined
	receiverClass ifNil:[ ^self ].
	receiverClass := nil.
	self 
		removeTitle;
		initializeSymbols;
		narrowCompletion;
		changed.


	! !

!ECompletionMorph methodsFor: 'private' stamp: 'bar 11/18/2004 22:50'!
setTitle 
	| titleString |
	receiverClass ifNil:[^self].
	titleString := receiverClass printString.
	titleStringMorph contents: titleString.
	titleStringMorph owner x: 0 y: 0.


! !

!ECompletionMorph methodsFor: 'private' stamp: 'bar 10/28/2004 08:57'!
delete
	self model completionMorphDeleted.
	super delete! !

!ECompletionMorph methodsFor: 'private' stamp: 'bar 11/25/2004 15:09'!
getPosition: aString
	| caret position bottomLeft topLeft |
	caret := editor startBlock stringIndex.
	[editor selectAt: caret - aString size.
	bottomLeft := paragraph selectionRects first bottomLeft.
	topLeft := editor morph owner submorphBounds topLeft.
	position := topLeft + bottomLeft] ensure:[editor selectAt: caret].
	^position. 
! !

!ECompletionMorph methodsFor: 'private' stamp: 'bar 10/18/2004 10:54'!
addInstanceVariablesFor: aClass 
	| instanceVars |
	aClass ifNil:[^self].
	instanceVars := aClass allInstVarNames asSortedCollection.
	allSymbols addAll: ( instanceVars collect:[ :each | #instance -> each ] ).
! !

!ECompletionMorph methodsFor: 'private' stamp: 'bar 11/18/2004 22:01'!
addLocalsVariables: aClass
	| locals parserClass method |
	aClass isNil ifTrue:[^self].
	(Smalltalk at: #RBParser ifAbsent:[nil]) notNil
		ifTrue:
			[method := [RBParser parseMethod: editor text] 
				on: Exception
				do: [nil]].
	locals := method notNil
		ifTrue:[method allDefinedVariables asSet asSortedCollection]
		ifFalse:
			[parserClass := aClass parserClass new.
			parserClass parseArgsAndTemps: editor text notifying: nil].
	locals notNil 
		ifTrue:
			[allSymbols addAll: (locals collect:[ :each | #local -> each ])]! !

!ECompletionMorph methodsFor: 'drawing' stamp: 'bar 11/18/2004 11:17'!
selectColor: anInteger

	anInteger isNil ifTrue:[ ^Color blue].
	^anInteger = self selected 
		ifTrue:[Color red] 
		ifFalse:[Color black].
! !

!ECompletionMorph methodsFor: 'initialization' stamp: 'bar 11/18/2004 22:53'!
initializeSymbols
	| selectedClass |
	selected := 0.
	selectedSymbols := nil.
	selectedClass := editor model selectedClassOrMetaClass.
	allSymbols := OrderedCollection new.
	receiverClass notNil 
		ifTrue: [self addSelectorsFor: receiverClass]
		ifFalse: 
			[self model addSymbols: allSymbols.
			self addLocalsVariables: selectedClass.
			self addInstanceVariablesFor: selectedClass.
			self addSelectors].
	self createTitle! !

!ECompletionMorph methodsFor: 'drawing' stamp: 'bar 11/25/2004 09:48'!
drawTitleOn: aCanvas
	"| morphicTransform angle |
	angle := 90 degreesToRadians.
	morphicTransform := MorphicTransform offset: self position angle: angle scale: 1.0.
	aCanvas 
		transformBy: morphicTransform
		clippingTo: self owner innerBounds
		during: [:myCanvas | myCanvas drawString:'Ruben' at: self position font: self class titleFont color: Color blue]
		smoothing: 1."
		! !

!ECompletionMorph class methodsFor: 'preferences' stamp: 'bar 11/19/2004 20:53'!
scrollArrowSize
	^8! !

!ECompletionMorph methodsFor: 'private' stamp: 'bar 11/25/2004 15:48'!
addSelectors 
	| firstChar allSelectors |
	firstChar := editor getCompletionSymbol at: 1.
	allSelectors := self newSortedSelectorCollection.
	Symbol allSymbolTablesDo:[ :each | (each size > 0 and:[( each at: 1 ) == firstChar]) 
		ifTrue:[allSelectors add: #selector -> each ]].
	allSymbols addAll: allSelectors.
	
! !

!ECompletionMorph class methodsFor: 'preferences' stamp: 'pk 6/3/2004 22:46'!
backgroundColor

	"CompletionMorph backgroundColor "

	^ Color r: 0.95 g: 0.95 b: 0.8 alpha: 0.9.! !

!ECompletionMorph methodsFor: 'actions' stamp: 'bar 11/25/2004 15:02'!
narrowCompletion
	| symbol |
	selected := 0.
	firstVisible := 1.
	symbol := editor getCompletionSymbol.
	symbol isEmpty 
		ifTrue: 
			[self delete.
			^self].
	selectedSymbols := allSymbols 
				select: [:each | each value beginsWith: symbol].
	selectedSymbols isEmpty ifTrue: [^self].
	selectedSymbols size = 1 
		ifTrue: 
			[self insertCompletion: ( self selectedSymbolAt: 1).
			self delete]
		ifFalse: 
			[self position: (self getPosition: symbol).
			self show]! !

!ECompletionMorph methodsFor: 'private' stamp: 'bar 10/17/2004 15:15'!
lastVisible

	^ (self firstVisible + self height-1)  min: (self itemsCount).! !

!ECompletionMorph class methodsFor: 'preferences' stamp: 'bar 10/16/2004 21:58'!
selectorFont
	^TextStyle defaultFont! !

!ECompletionMorph methodsFor: 'private' stamp: 'bar 10/28/2004 08:57'!
currentCompiledMethod
	^self model currentCompiledMethod! !

!ECompletionMorph class methodsFor: 'instance creation' stamp: 'bar 11/18/2004 22:56'!
completeParagraph: aParagraph editor: aParagraphEditor 
	| newObject |
	newObject := self new.
	newObject 
		setParagraph: aParagraph
		editor: aParagraphEditor.
	^newObject! !

!ECompletionMorph methodsFor: 'accessing' stamp: 'bar 10/17/2004 16:13'!
active

	^selected ~= 0! !

!ECompletionMorph methodsFor: 'drawing' stamp: 'bar 11/25/2004 09:54'!
prepareRectForNextRow: aRectangle 
	^aRectangle translateBy: 0 @ ECompletionMorph itemHeight! !

!ECompletionMorph methodsFor: 'private' stamp: 'bar 11/25/2004 11:43'!
show
	| extent width |
	selected := 0.
	firstVisible := 1.
	width := self visibleItemsCount * ECompletionMorph itemHeight.
	titleStringMorph 
		ifNotNil: [width := width max: titleStringMorph width + 30].
	extent := ECompletionMorph itemWidth @ width.
	self extent: extent.
	self position: self position - (20@0).
	self openInWorld! !

!ECompletionMorph methodsFor: 'actions' stamp: 'bar 10/18/2004 07:48'!
completeFirst
	| firstSymbol |
	selectedSymbols size == 0 ifTrue: [^self].
	firstSymbol := self selectedSymbolAt: 1.
	self insertCompletion: firstSymbol.
	self delete! !

!ECompletionMorph methodsFor: 'private' stamp: 'bar 10/17/2004 15:14'!
selected: aNumber 
	"Set the value of selected"

	selectedSymbols 
		ifNotNil: 
			[((1	to: self itemsCount) 	includes: aNumber) 
				ifTrue: [selected := aNumber]]! !

!ECompletionMorph methodsFor: 'drawing' stamp: 'bar 11/25/2004 09:54'!
drawOn: aCanvas 
	| rectangle |
	super drawOn: aCanvas.
	self drawTitleOn: aCanvas.
	rectangle := self bounds copy.
	rectangle bottom: rectangle top + ECompletionMorph itemHeight.
	rectangle := rectangle left: rectangle left + 20.
	self extent: self extent.
	self firstVisible ~= 1 ifTrue: [self drawTopScrollArrowOn: aCanvas].
	self lastVisible ~= self itemsCount 
		ifTrue: [self drawBottomScrollArrowOn: aCanvas].
	selectedSymbols isEmpty ifTrue: [^self].
	self firstVisible to: self lastVisible
		do: 
			[:index | 
			| symbol type string |
			symbol := selectedSymbols at: index.
			type := symbol key.
			string := symbol value.
			aCanvas 
				drawString: string
				in: (rectangle insetBy: 1)
				font: (self selectFont: type)
				color: (self selectColor: index).
			rectangle := self prepareRectForNextRow: rectangle]! !

!ECompletionMorph methodsFor: 'actions' stamp: 'pk 6/3/2004 16:42'!
moveDown

	self selected: (self selected + 1).

	((self selected > self lastVisible)  and: [self selected <= self itemsCount ])
		ifTrue: [ firstVisible := firstVisible + 1 ].

	self changed.! !

!ECompletionMorph methodsFor: 'actions' stamp: 'bar 11/25/2004 14:41'!
insertSelected
	| new |
	self active ifFalse: [^false].
	new := self selectedSymbolAt: selected.
	self insertCompletion: new.
	self delete.
	^true! !

!ECompletionMorph methodsFor: 'private' stamp: 'bar 10/28/2004 08:57'!
model
	^editor model! !

!ECompletionMorph methodsFor: 'initialization' stamp: 'bar 11/25/2004 15:03'!
setParagraph: aParagraph editor: aParagraphEditor
	paragraph := aParagraph.
	editor := aParagraphEditor.
	(self class allowModel: self model) 
		ifFalse: 
			[self delete.
			^self].
	receiverClass := self model getClassForName: editor getCompletionReceiver.
	self initializeSymbols.
	self narrowCompletion.! !

!ECompletionMorph class methodsFor: 'preferences' stamp: 'bar 10/17/2004 15:16'!
maxLength

	"CompletionMorph maxLength "
	
	^30.! !

!ECompletionMorph methodsFor: 'title' stamp: 'bar 11/18/2004 22:54'!
removeTitle
	titleStringMorph ifNil:[ ^self ].
	self removeMorph: titleStringMorph owner.
	titleStringMorph _ nil.
	! !

!ECompletionMorph methodsFor: 'actions' stamp: 'bar 10/28/2004 10:51'!
moveUp
	(self selected = 0 and:[ self firstVisible = 1]) ifTrue:[^self].
	self selected: self selected - 1.
	self selected < self firstVisible 
		ifTrue: [firstVisible := firstVisible - 1].
	self changed! !

!ECompletionMorph methodsFor: 'initialization' stamp: 'bar 11/18/2004 14:10'!
initialize

	super initialize.
	
	self color: self class backgroundColor.
	! !

!ECompletionMorph methodsFor: 'drawing' stamp: 'bar 11/18/2004 11:18'!
selectFont: aSymbol 
	| font |
	font := aSymbol == #local 
		ifTrue: [self class localVariablesFont]
			ifFalse: 
				[aSymbol == #instance 
					ifTrue: [self class instanceVariablesFont]
					ifFalse: [self class selectorFont]].
	^font! !

!ECompletionMorph methodsFor: 'private' stamp: 'bar 10/16/2004 17:06'!
itemsCount
	selectedSymbols ifNil: [^0].
	^selectedSymbols size! !

!ECompletionMorph methodsFor: 'drawing' stamp: 'bar 11/19/2004 20:54'!
drawTopScrollArrowOn: aCanvas 
	| aPoligon point arrowHeight |
	arrowHeight := self class scrollArrowSize.
	point := self bounds topLeft translateBy: 6 @ 11.
	aPoligon := Array 
				with: point
				with: (point translateBy: arrowHeight @ 0)
				with: (point translateBy: arrowHeight / 2 @ arrowHeight negated).
	aCanvas 
		drawPolygon: aPoligon 
		fillStyle: self class scrollColor. 
	! !

!ECompletionMorph methodsFor: 'accessing' stamp: 'bar 10/17/2004 12:20'!
selectedSymbolAt: aNumber 
	^(selectedSymbols at: aNumber) value! !

!ECompletionMorph class methodsFor: 'preferences' stamp: 'bar 10/17/2004 12:09'!
localVariablesFont
	localVariablesFont := nil.
	localVariablesFont ifNil:[localVariablesFont := StrikeFont familyName: 'Accuny' size: 12 emphasized: 4 ].
	^localVariablesFont
	! !

!ECompletionMorph class methodsFor: 'preferences' stamp: 'pk 6/3/2004 00:09'!
scrollColor

	"CompletionMorph scrollColor "

	^ Color r: 1 g: 0.55 b: 0.4 alpha: 0.9.! !

!ECompletionMorph methodsFor: 'private' stamp: 'bar 11/25/2004 15:01'!
addSelectorsFor: aClass 
	| firstChar allSelectors selectors classes |
	firstChar := editor getCompletionSymbol at: 1.
	selectors := Set new.
	classes := aClass allSuperclasses.
	classes add: aClass.
	classes do:
		[:eachClass | eachClass methodDictionary keysDo: 
			[:each | 
			(each size > 0 and: [(each at: 1) == firstChar]) 
				ifTrue: [selectors add: #selector -> each]]].
	allSelectors := self newSortedSelectorCollection.
	allSelectors addAll: selectors.
	allSymbols addAll: allSelectors.! !

!ECompletionMorph class methodsFor: 'accessing' stamp: 'bar 11/29/2004 08:01'!
allowModel: aModel 

	^aModel notNil and:[aModel isKindOf: StringHolder]! !

!ECompletionMorph methodsFor: 'drawing' stamp: 'bar 11/19/2004 20:51'!
drawBottomScrollArrowOn: aCanvas 
	| aPoligon point arrowHeight |
	point := self bounds bottomLeft translateBy: 6 @ -15.
	arrowHeight := self class scrollArrowSize.
	aPoligon := Array 
				with: point
				with: (point translateBy: arrowHeight @ 0)
				with: (point translateBy: arrowHeight / 2 @ arrowHeight).
	aCanvas drawPolygon: aPoligon fillStyle: self class scrollColor! !

!TextMorph methodsFor: '*ecompletion-override' stamp: 'bar 11/29/2004 08:01'!
keyStroke: evt 
	"Handle a keystroke event."

	| action completionAllowed stringHolder |
	stringHolder := editor model.
	completionAllowed := ECompletionMorph allowModel: stringHolder.
	completionAllowed 
		ifTrue: [(self handleCompletionKeyStroke: evt) ifTrue: [^self]].
	evt keyValue = 13 
		ifTrue: 
			[action := self crAction.
			action ifNotNil: 
					["Note: Code below assumes that this was some 
					input field reacting on CR. Break the keyboard 
					focus so that the receiver can be safely deleted."

					evt hand newKeyboardFocus: nil.
					^action value]].
	self handleInteraction: [editor readKeyboard] fromEvent: evt.
	self updateFromParagraph.
	super keyStroke: evt.
	"sends to keyStroke event handler, if any"

	"Narrow the completion with any of the keys"
	(completionAllowed and:[stringHolder isCompletionMorphOpen]) 
		ifTrue: [stringHolder narrowCompletion]! !

!TextMorph methodsFor: '*ecompletion' stamp: 'bar 11/25/2004 15:44'!
handleCompletionKeyStroke: aKeyboardEvent 
	"I return a boolean. true when I have handled the event and no futher processing 
	is needed by the caller."

	| stringHolder keyValue controlKeyPressed |
	stringHolder := editor model.
	keyValue := aKeyboardEvent keyValue.
	controlKeyPressed := aKeyboardEvent controlKeyPressed.
	"Ctrl-Space or Tab for open"
	stringHolder isCompletionMorphOpen ifFalse:
	     [(keyValue = 32 & controlKeyPressed or:[ keyValue = 9])
		     ifTrue:
		          [editor getCompletionSymbol isEmpty ifFalse:
			     	[stringHolder 
						completeParagraph: paragraph 
						editor: editor. 
			     	^true]].
		     ^false]. 
	"Arrow up"
	keyValue = 30 
		ifTrue: 
			[stringHolder completionSelectionUp.
			^true].
	"Arrow down"
	keyValue = 31 
		ifTrue: 
			[stringHolder completionSelectionDown.
			^true].
	"Tab or Ctrl-Space"
	(keyValue = 32 & controlKeyPressed or:[keyValue = 9])
		ifTrue: 
			[stringHolder completeFirst.
			^true].
	"Esc"
	keyValue = 27 
		ifTrue: 
			[stringHolder deleteCompletionMorph.
			^true].
	"CR"
	keyValue = 13 
		ifTrue: [stringHolder completionInsertSelected ifTrue: [^true]].
	"Ctrl u"
	keyValue = 21 & controlKeyPressed 
		ifTrue: 
			[stringHolder completionSwitchToUndefined.
			^true].
	^false! !

!Workspace methodsFor: '*ecompletion' stamp: 'bar 10/28/2004 10:14'!
addSymbols: aCollection
	super addSymbols: aCollection.
	bindings 
		ifNotNil:[bindings keysDo:[ :each | aCollection add: #local -> each ]].

! !

!Workspace methodsFor: '*ecompletion' stamp: 'bar 10/28/2004 10:14'!
getClassForName: aString
	| binding |
	bindings 
		ifNotNil:[binding := bindings 
			at: aString  
			ifAbsent:[nil].
		binding ifNotNil:[^binding class]].
	^super getClassForName: aString! !

!String methodsFor: '*ecompletion' stamp: 'bar 11/18/2004 11:04'!
indexOfFirstUppercaseCharacter
	| position found input |
	position := 0.
	found := false.
	input := ReadStream on: self.
	[input atEnd | found ] 
		whileFalse:
			[input next isUppercase 
				ifTrue:[ found := true ]. 
			position := position + 1].
	found 
		ifTrue:[ ^position ]
		ifFalse:[ ^0 ]
! !

!CodeHolder methodsFor: '*ecompletion-override' stamp: 'bar 10/28/2004 08:53'!
contentsChanged

	super contentsChanged.
	self changed: #annotation.
	self deleteCompletionMorph

	
! !

!CodeHolder methodsFor: '*ecompletion' stamp: 'bar 10/12/2004 23:37'!
currentCompiledMethod
	^currentCompiledMethod! !

!CodeHolder methodsFor: '*ecompletion' stamp: 'bar 10/28/2004 08:51'!
getClassForName: aString
	aString = 'self' ifTrue:[^self selectedClassOrMetaClass].
	aString = 'super' ifTrue:[^self selectedClassOrMetaClass superclass].
	^super getClassForName: aString.
! !

!ParagraphEditor methodsFor: '*ecompletion' stamp: 'bar 10/18/2004 07:08'!
changeCaretDuring: aBlock
	| caret |
	caret := self startBlock stringIndex.
	[aBlock value] ensure:[self selectAt: caret]! !

!ParagraphEditor methodsFor: '*ecompletion' stamp: 'pk 5/31/2004 21:40'!
getPrecedingIdentifier 

	| string sep stop tok |
	tok _ false.
	string _ paragraph text string.
	stop _ stopBlock stringIndex - 1.
"	[stop > 0 and: [(string at: stop) isSeparator]] whileTrue: [stop _ stop - 1].
"	sep _ stop.
	[sep > 0 and: [(string at: sep) tokenish]] whileTrue: [tok _ true. sep _ sep - 1].
	tok ifTrue: [self selectInvisiblyFrom: sep + 1 to: stop]
! !

!ParagraphEditor methodsFor: '*ecompletion' stamp: 'bar 10/18/2004 07:09'!
caret
	^self startBlock stringIndex! !

!ParagraphEditor methodsFor: '*ecompletion' stamp: 'bar 10/18/2004 07:02'!
getPrecedingIdentifierFrom: aNumber 

	| string sep stop tok |
	tok := false.
	string := paragraph text string.
	stop := aNumber.
	sep := stop.
	[sep > 0 and: [(string at: sep) tokenish]] 
		whileTrue: [tok := true. sep := sep - 1].
	tok ifTrue: 
		[self 
			selectInvisiblyFrom: sep + 1 
			to: stop]
! !

!ParagraphEditor methodsFor: '*ecompletion' stamp: 'bar 11/25/2004 15:16'!
completion
	(ECompletionMorph allowModel: model) ifFalse: [^self].
	model isCompletionMorphOpen ifFalse:[^self].
	self model narrowCompletion! !

!ParagraphEditor methodsFor: '*ecompletion' stamp: 'bar 11/25/2004 15:00'!
getCompletionSymbol
	
	self changeCaretDuring:
		[| symbol caret |
		caret := self caret.
		symbol := self
			getPrecedingIdentifierFrom: caret - 1;
			selection.
		^symbol].! !

!ParagraphEditor methodsFor: '*ecompletion' stamp: 'bar 11/25/2004 15:02'!
getCompletionReceiver
	
	| symbol |
	symbol := self getCompletionSymbol.
	self changeCaretDuring:
		[| receiver caret |
		caret := self caret.
		receiver := self
			getPrecedingIdentifierFrom: caret - symbol size - 2;
			selection.
		^receiver asString]! !
